]> diplodocus.org Git - nmh/blob - man/fmttest.man
908b3cbe073328d50f862adc6281599bd28e0869
[nmh] / man / fmttest.man
1 .TH FMTTEST %manext1% "August 24, 2014" "%nmhversion%"
2 .\"
3 .\" %nmhwarning%
4 .\"
5 .SH FMTTEST
6 fmttest \- test tool for the
7 .IR mh-format (5)
8 language
9 .SH SYNOPSIS
10 .HP 5
11 .na
12 .B fmttest
13 .RB [ \-form
14 .IR formatfile ]
15 .RB [ \-format
16 .IR formatstring ]
17 .RB [ \-address " | " \-raw " | " \-date " | " \-message ]
18 .RB [ \-file " | " \-nofile ]
19 .RB [ \-\|\-component
20 .IR component-text ]
21 .RB [ \-dupaddrs " | " \-nodupaddrs ]
22 .RB [ \-ccme " | " \-noccme ]
23 .RB [ \-outsize
24 .IR size-in-characters ]
25 .RB [ \-width
26 .IR column-width ]
27 .RB [ \-msgnum
28 .IR number ]
29 .RB [ \-msgcur
30 .IR flag ]
31 .RB [ \-msgsize
32 .IR size ]
33 .RB [ \-unseen
34 .IR flag ]
35 .RB [ \-dump " | " \-nodump ]
36 .RB [ \-trace " | " \-notrace ]
37 .RI [ +folder ]
38 .RI [ msgs " | " strings ]
39 .ad
40 .SH DESCRIPTION
41 .B Fmttest
42 is used to test programs written for the
43 .B nmh
44 format language as specified by
45 .IR mh-format (5).
46 It is also intended to replace the
47 .BR ap ,
48 .BR dp ,
49 and
50 .B fmtdump
51 programs.
52 .PP
53 .SS FORMAT PROGRAM SELECTION
54 The
55 .B \-format
56 .I string
57 and
58 .B \-form
59 .I formatfile
60 switches may be used to specify a format string or a format file to read.
61 If given a format string, it must be specified as a single argument to
62 the
63 .B \-format
64 switch. If given a format file name with
65 .BR \-form ,
66 the file is searched for using the normal
67 .B nmh
68 rules: absolute pathnames are accessed directly, tilde expansion is
69 done on usernames, and files are searched for in the user's
70 .I Mail
71 directory as specified in their profile. If not found there, the directory
72 .RI \*(lq %etcdir% \*(rq
73 is checked.
74 .SS MODE SELECTION AND COMPONENT SPECIFICATION
75 .B Fmttest
76 has four operating modes: address mode, raw mode, date mode, and message
77 mode. These modes are selected by the
78 .BR \-address ,
79 .BR \-raw ,
80 .BR \-date ,
81 and
82 .B \-message
83 switches respectively.
84 .PP
85 Address mode treats every argument as an email address and processes it
86 with nmh's email parser. Each argument is processed with the specified
87 format program with the parsed email address available as a special
88 .RI %{ text }
89 component escape, and the output from the program is printed on standard output.
90 If there was an error parsing the email address the error message is
91 stored in the
92 .RI %{ error }
93 component escape. If no format program is given on the command line, the
94 following default program is used:
95 .PP
96 .RS 5
97 .nf
98 %<{error}%{error}: %{text}%|%(putstr(proper{text}))%>
99 .fi
100 .RE
101 .PP
102 In this mode
103 .B fmttest
104 is equivalent to
105 .IR ap (8).
106 .PP
107 In raw mode, no processing of the specified arguments is done. Each argument
108 is run against the specified format program with the argument text available
109 in the
110 .RI %{ text }
111 component. You must specify a format with
112 .B \-form
113 or
114 .B \-format
115 when using raw mode.
116 .PP
117 Date mode is identical to raw mode, with one exception: if no format is
118 specified, the following format string is used:
119 .PP
120 .RS 5
121 .nf
122 %<(nodate{text})error: %{text}%|%(putstr(pretty{text}))%>
123 .fi
124 .RE
125 .PP
126 Date mode is equivalent to
127 .IR dp (8).
128 .PP
129 In message mode the arguments to
130 .B fmttest
131 are interpreted as an optional folder and messages.
132 .B Fmttest
133 will read each specified message and make all of the components in the
134 message available to the format program. Also, the appropriate information
135 for the
136 .RI %( msg ),
137 .RI %( cur ),
138 .RI %( unseen ),
139 and
140 .RI %( size )
141 function escapes will be made available for each message. If the
142 .B \-file
143 switch is given, the arguments are interpreted as filenames instead of
144 message numbers, but otherwise the behavior is the same (except that the
145 .RI %( msg ),
146 .RI %( cur ),
147 and
148 .RI %( unseen )
149 function escapes will not provide any useful information).
150 .PP
151 The default format used in address mode is the default format used by
152 .BR scan .
153 The following command can replicate the functionality of the
154 .B repl
155 command.
156 .PP
157 .RS 5
158 .nf
159 fmttest \-nodupaddrs \-form replcomps \-outsize max [+folder] message
160 .fi
161 .RE
162 .PP
163 Regardless of the mode, other components can be provided to the format
164 program by the use of the
165 .B \-\|\-component
166 switch. For example, the following program will test out the use of
167 the
168 .RB \*(lq encrypted \*(rq
169 component:
170 .PP
171 .RS 5
172 .nf
173 fmttest \-\|\-encrypted yes \-message cur
174 .fi
175 .RE
176 .PP
177 In message mode components supplied on the command line will override
178 components from messages.
179 .SS ADDITIONAL SWITCHES
180 The
181 .B \-dupaddrs
182 and
183 .B \-nodupaddrs
184 switches control whether duplicate addresses are allowed or suppressed by the
185 .B FORMATADDR
186 instruction, which is used by the
187 .RI `%( formataddr )'
188 function escape. In normal operation duplicate addresses are only
189 suppressed by
190 .BR repl .
191 .PP
192 The
193 .B \-ccme
194 and
195 .B \-noccme
196 switches control whether or not to count the user's local mailbox as a
197 duplicate address. This replicates the behavior of the
198 .B \-cc
199 .I me
200 switch to
201 .BR repl ,
202 and only applies if
203 .B \-nodupaddrs
204 is in effect.
205 .PP
206 The
207 .B \-outsize
208 switch controls the maximum number of printable characters that the format
209 engine will produce. Characters marked as non-printing by the format
210 engine with
211 .RI `%( zputlit )',
212 characters with zero width, and extra bytes that are
213 part of a multibyte character are not counted against this total.
214 Two special values are supported:
215 .RI \*(lq max \*(rq,
216 which will set the value to the maximum value of an integer, and
217 .RI \*(lq width \*(rq,
218 which will set the
219 value to the width of the terminal. In message mode it defaults to the
220 terminal width, otherwise the default is the maximum value of an integer.
221 .PP
222 The
223 .B \-width
224 switch controls the column width which is used by the
225 .RI `%( width )'
226 function escape. By default is set to the terminal width.
227 .PP
228 The
229 .BR \-msgnum ,
230 .BR \-msgcur ,
231 .BR \-msgsize ,
232 and the
233 .B \-unseen
234 switches all control the values used, respectively, by the following
235 function escapes:
236 .RI `%( num )',
237 .RI `%( cur )',
238 .RI `%( size )',
239 and
240 .RI `%( unseen )'.
241 If none are supplied these values are taken from the message in message mode;
242 in all other modes the default values are 0.
243 .SS COMPILING AND TRACING FORMAT PROGRAMS
244 The
245 .B \-dump
246 switch outputs the complete set of format instructions for the specified
247 format program. The
248 .B \-trace
249 switch will output each format instruction as it is being
250 executed, and show the values of the
251 .I num
252 and
253 .I str
254 registers if they have changed from the previous instruction.
255 The output buffer is also printed if it has changed from the previous
256 instruction.
257 .SS FORMAT INSTRUCTIONS
258 It should be noted that there is not a one-to-one correspondence between
259 format escapes and format instructions; many instructions have side
260 effects. Instructions prefixed with
261 .RI \*(lq LV \*(rq
262 generally return a integer into the
263 .I num
264 (value) register; instructions prefixed with a
265 .RI \*(lq LS \*(rq
266 return a string into the
267 .I str
268 register.
269 .PP
270 .nf
271 .ta \w'LS_DECODECOMP 'u
272 .I "Instruction Description"
273 COMP Output component
274 COMPF Formatted output component
275 LIT Output literal text
276 LITF Formatted literal text output
277 CHAR Output single character
278 NUM Output the \fInum\fR register
279 NUMF Formatted output of the \fInum\fR register
280 STR Output the \fIstr\fR register
281 STRF Formatted output of the \fIstr\fR register
282 STRFW Not used
283 PUTADDR Output address list in \fIstr\fR register
284 STRLIT Output \fIstr\fR, no space compression
285 STRLITZ Like \fBSTRLIT\fR, but not counted against width
286 LS_COMP Write component to \fIstr\fR register
287 LS_LIT Write literal to \fIstr\fR register
288 LS_GETENV Write environment var to \fIstr\fR register
289 LS_DECODECOMP Decode RFC 2047 encoded component to \fIstr\fR register
290 LS_DECODE Decode RFC 2047 encoded string to \fIstr\fR register
291 LS_TRIM Trim trailing whitespace from \fIstr\fR register
292 LV_COMP Convert component to integer, store in \fInum\fR register
293 LV_COMPFLAG Set \fInum\fR to 1 if \fBTRUE\fR set in component
294 LV_LIT Load literal value into \fInum\fR register
295 LV_DAT Load value from \fIdat\fR array into \fInum\fR register (see note)
296 LV_STRLEN Set \fInum\fR to the length of \fIstr\fR
297 LV_PLUS_L Add value to \fInum\fR register
298 LV_MINUS_L Substract value from \fInum\fR register
299 LV_DIVIDE_L Divide \fInum\fR register by value
300 LV_MODULO_L \fInum\fR modulo value
301 LV_CHAR_LEFT Store remaining number of printable chars in \fInum\fR
302 LS_MONTH Write short name of month to \fIstr\fR from date component
303 LS_LMONTH Write long name of month to \fIstr\fR from date component
304 LS_ZONE Write time zone offset to \fIstr\fR from date component
305 LS_DAY Write short name of day of week to \fIstr\fR from date component
306 LS_WEEKDAY Write long name of day of week to \fIstr\fR from date component
307 LS_822DATE Write RFC 822 compatible date to \fIstr\fR from date component
308 LS_PRETTY Write date with \*(lqpretty\*(rq timezone to \fIstr\fR
309 LV_SEC Write date component seconds to \fInum\fR
310 LV_MIN Write date component minutes to \fInum\fR
311 LV_HOUR Write date component hour to \fInum\fR
312 LV_MON Write date component numeric month to \fInum\fR (start at 1)
313 LV_YEAR Write date component year to \fInum\fR
314 LV_YDAY Write date component Julian day to \fInum\fR
315 LV_WDAY Write date component day of week to \fInum\fR (0 == Sunday)
316 LV_ZONE Write date component time zone offset to \fInum\fR
317 LV_CLOCK Write date component in Unix epoch time to \fInum\fR
318 LV_RCLOCK Write offset of date component from current time to \fInum\fR
319 LV_DAYF Write 1 to \fInum\fR if day of week is explicit
320 LV_DST Write 1 to \fInum\fR if DST is in effect for date component
321 LV_ZONEF Write 1 to \fInum\fR if timezone is explicit
322 LS_ADDR Write email address of addr component to \fIstr\fR
323 LS_PERS Write personal name of addr component to \fIstr\fR
324 LS_MBOX Write mailbox (username) of addr component to \fIstr\fR
325 LS_HOST Write host of addr component to \fIstr\fR
326 LS_PATH Write host route of addr component to \fIstr\fR
327 LS_GNAME Write group name of addr component to \fIstr\fR
328 LS_NOTE Write note portion of addr component to \fIstr\fR
329 LS_822ADDR Write \*(lqproper\*(rq RFC 822 version of addr component to \fIstr\fR
330 LS_FRIENDLY Write friendly (name or note) of address component to \fIstr\fR
331 LS_UNQUOTE Remove RFC 2822 quotes from string
332 LV_HOSTTYPE Set \fInum\fR to type of host (0=local, 1=network)
333 LV_INGRPF Set \fInum\fR to 1 if address was inside of group
334 LV_NOHOSTF Set \fInum\fR to 1 of no host was present in address component
335 LOCALDATE Convert date component to local timezone
336 GMTDATE Convert date component to GMT
337 PARSEDATE Parse date component
338 PARSEADDR Parse address component
339 FORMATADDR Add address component to list in \fIstr\fR
340 CONCATADDR Like \fBFORMATADDR\fR, but will not suppress duplicates
341 MYMBOX Set \fInum\fR if address component is a local address
342 SAVESTR Save \fIstr\fR register temporarily
343 DONE End program
344 NOP No operation
345 GOTO Jump to new instruction
346 IF_S_NULL Branch if \fIstr\fR is \fBNULL\fR
347 IF_S Branch if \fIstr\fR is not \fBNULL\fR
348 IF_V_EQ Branch if \fInum\fR is equal to value
349 IF_V_NE Branch if \fInum\fR is not equal to value
350 IF_V_GT Branch if \fInum\fR is greater than value
351 IF_MATCH Branch if \fIstr\fR contains string
352 IF_AMATCH Branch if \fIstr\fR starts with string
353 S_NULL Set \fInum\fR to 1 if \fIstr\fR is \fBNULL\fR
354 S_NONNULL Set \fInum\fR to 1 if \fIstr\fR is not \fBNULL\fR
355 V_EQ Set \fInum\fR to 1 if \fInum\fR equals value
356 V_NE Set \fInum\fR to 1 if \fInum\fR does not equal value
357 V_GT Set \fInum\fR to 1 if \fInum\fR is greater than value
358 V_MATCH Set \fInum\fR to 1 if \fIstr\fR contains string
359 V_AMATCH Set \fInum\fR to 1 if \fIstr\fR starts with string
360 .fi
361 .PP
362 The
363 .B LV_DAT
364 instruction is a bit special. Callers of the format library pass in an
365 array of integers that are used by certain format escapes. The current
366 list of format escapes and the indexes they use are:
367 .PP
368 .RS 5
369 .nf
370 .ta \w'dat[5]\0\0'u
371 dat[0] %(\fInum\fR)
372 dat[1] %(\fIcur\fR)
373 dat[2] %(\fIsize\fR)
374 dat[3] %(\fIwidth\fR)
375 dat[4] %(\fIunseen\fR)
376 .fi
377 .RE
378 .SH "SEE ALSO"
379 .IR mh-format (5),
380 .IR repl (1),
381 .IR ap (8),
382 .IR dp (8),
383 .SH DEFAULTS
384 .nf
385 .RB ` \-message '
386 .RB ` \-nofile '
387 .RB ` \-dupaddrs '
388 .fi
389 .SH BUGS
390 It shouldn't require as much code from other programs as it does.